UNIT mTEmpfaenger;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses
  mTNetzHW, classes, windows, sysUtils;

type
   TEreignis = procedure of object;

   TEmpfaenger = CLASS(TThread)

     // weitere Attribute
     private
        puffer       : string;
        baud         : integer;
        HW           : TNetzHW;
        bitZeit      : integer;
        rueckmeldung : byte;
     //Objektbeziehungen:
        // kenntTNetzHW : TNetzHW;

     // weitere Methoden
     public
        OnChange  : TEreignis;
        constructor create; virtual;
        procedure execute; override;
        procedure SetBaud (pBaud: integer); virtual;
        procedure SetPuffer(pPuffer : string); virtual;
        function GetPuffer : string;
        procedure SetzeHW (pHW: TNetzHW); virtual;
        function GetBaud : integer; virtual;
     private
       procedure empfange_Byte(var b : byte; var fehler : boolean);
       procedure sende_Byte(b : byte);
   end;

implementation

var
  c : TLargeInteger;

procedure warte(dt : real);
var
  t1,t2,t : real;
  n       : TLargeInteger;
begin
  QueryPerformanceCounter(n);
  t1 := n/c; t2 := t1+dt;
  repeat
    QueryPerformanceCounter(n);
    t := n/c;
  until t > t2;
end;


//-------- create (public) ---------------------------------------------
constructor TEmpfaenger.create;
begin
  inherited create(true);
  FreeOnTerminate := true;
  puffer := '';
end;

procedure TEmpfaenger.empfange_Byte(var b: byte; var fehler : boolean);
var
  paritaet : boolean;
  i        : integer;
begin
  b := 0; paritaet := false;
  // auf StartBit warten
  while HW.GetEin <> true do sleep(0);
  // Mitte Bit0 erreicht
  sleep(bitZeit+ bitZeit div 2);
  // Bits abtasten
  for i := 0 to 7 do
  begin
    b := b shr 1;
    if HW.GetEin
    then
    begin
      b := b+128;
      paritaet := not paritaet;
    end;
    sleep(bitZeit);
  end;
  // Parittsbit
  fehler :=  HW.GetEin <> paritaet;
  sleep(bitZeit);
  // Mitte StoppBit erreicht
  sleep(bitZeit div 2);
end;

procedure TEmpfaenger.sende_Byte(b : byte);
var
  paritaet : boolean;
  j        : integer;
begin
  paritaet := false;
  // StartBit
  HW.SetAus(true);
  sleep(bitZeit);
  // DatenBits
  for j := 0 to 7 do
  begin
    if b and 1 = 1
    then
    begin
      HW.SetAus(true); paritaet := not paritaet;
    end
    else
    begin
      HW.SetAus(false);
    end;
    b := b shr 1;
    sleep(bitZeit);
  end;
  // ParittsBit
  if paritaet then HW.SetAus(true) else HW.SetAus(false);
  sleep(bitZeit);
  // StoppBit
  HW.SetAus(false);
  sleep(bitZeit);
end;


//-------- execute (public) --------------------------------------------
procedure TEmpfaenger.execute;
var
  n,i,j     : integer;
  b         : byte;
  fehler    : boolean;
  c,nt      : TLargeInteger;
  t,tout    : real;
begin
  bitZeit := round(1000/baud);
  while not Terminated do
  begin
    empfange_Byte(b,fehler);
    if not fehler
    then
    begin
      puffer := puffer+chr(b);
      rueckmeldung := 255; // OK
    end
    else
    begin
      // puffer := puffer+chr(b)+'~';
      rueckmeldung := 0;   // Fehler
    end;
    sende_Byte(rueckmeldung);
    if Assigned(OnChange) then OnChange;
  end;
end;

//-------- SetBaud (public) --------------------------------------------
procedure TEmpfaenger.SetBaud (pBaud: integer);
begin
  baud := pBaud;
end;

//-------- SetSendeByte (public) ---------------------------------------
procedure TEmpfaenger.SetPuffer(pPuffer: string);
begin
  puffer := pPuffer;
  if Assigned(OnChange) then OnChange;
end;

function TEmpfaenger.GetPuffer : string;
begin
  result := puffer;
end;

//-------- SetzeHW (public) --------------------------------------------
procedure TEmpfaenger.SetzeHW (pHW: TNetzHW);
begin
  HW := pHW;
end;

//-------- GetBaud (public) --------------------------------------------
function TEmpfaenger.GetBaud : integer;
begin
  result := baud;
end;

begin
  QueryPerformanceFrequency(c);
end.
