UNIT mTSender;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses
  mTNetzHW, classes, windows, mTEmpfaenger;

type
   TSender = CLASS(TThread)

     // weitere Attribute
     private
        sendeStr     : string;
        baud         : integer;
        HW           : TNetzHW;
        bitZeit      : integer;
        rueckmeldung : byte;
        c            : TLargeInteger;
     //Objektbeziehungen:
        // kenntTNetzHW : TNetzHW;

     // weitere Methoden
     public
        constructor create; virtual;
        procedure execute; override;
        procedure SetBaud (pBaud: integer); virtual;
        procedure SetSendeStr (pSendeStr: string); virtual;
        procedure SetzeHW (pHW: TNetzHW); virtual;
        function GetBaud : integer; virtual;
     private
       procedure sende_Byte(b : byte);
       procedure empfange_Rueckmeldung;
   end;

implementation

uses
  uSenderEmpfaenger2, sysUtils;

//+---------------------------------------------------------------------
//|         TSender: Methodendefinition
//+---------------------------------------------------------------------

//-------- create (public) ---------------------------------------------
constructor TSender.create;
begin
  inherited create(true);
  FreeOnTerminate := true;
  QueryPerformanceFrequency(c);
end;

procedure TSender.sende_Byte(b : byte);
var
  paritaet : boolean;
  j        : integer;
begin
  paritaet := false;
  // StartBit
  HW.SetAus(true);
  sleep(bitZeit);
  // DatenBits
  for j := 0 to 7 do
  begin
    if b and 1 = 1
    then
    begin
      HW.SetAus(true); paritaet := not paritaet;
    end
    else
    begin
      HW.SetAus(false);
    end;
    b := b shr 1;
    sleep(bitZeit);
  end;
  // ParittsBit
  if paritaet then HW.SetAus(true) else HW.SetAus(false);
  sleep(bitZeit);
  // StoppBit
  HW.SetAus(false);
  sleep(bitZeit);
end;

procedure TSender.empfange_Rueckmeldung;
var
  paritaet : boolean;
  i        : integer;
  n,n1,n2  : TLargeInteger;
begin
  rueckmeldung := 0;
  QueryPerformanceCounter(n);
  n1 := n;
  n2 := n1 + round((20*BitZeit)/1000*c);
  // auf StartBit warten
  while (HW.GetEin <> true) do
  begin
    QueryPerformanceCounter(n);
    if n > n2 then exit;
    sleep(0);
  end;
  // Mitte Bit0 erreicht
  sleep(bitZeit + bitZeit div 2);
  // Bits abtasten
  for i := 0 to 7 do
  begin
    if HW.GetEin then Inc(rueckmeldung);
    sleep(bitZeit);
  end;
  // Parittsbit
  sleep(bitZeit);
  // Mitte StoppBit erreicht
  sleep(bitZeit div 2);
end;


//-------- execute (public) --------------------------------------------
procedure TSender.execute;
var
  n,i,j    : integer;
  b        : byte;
begin
  bitZeit := round(1000/baud);
  n := Length(SendeStr);
  i := 1;
  while i <= n do
  begin
    b := ord(sendeStr[i]);
    sende_Byte(b);
    empfange_Rueckmeldung;
    Form1.mSend.text := Form1.mSend.text+IntToStr(rueckmeldung);
    if rueckmeldung > 4 then inc(i); // mindestens 5 Bits gesetzt
  end;
end;

//-------- SetBaud (public) --------------------------------------------
procedure TSender.SetBaud (pBaud: integer);
begin
  baud := pBaud;
end;

//-------- SetSendeByte (public) ---------------------------------------
procedure TSender.SetSendeStr (pSendeStr: string);
begin
  sendeStr := pSendeStr;
end;

//-------- SetzeHW (public) --------------------------------------------
procedure TSender.SetzeHW (pHW: TNetzHW);
begin
  HW := pHW;
end;

//-------- GetBaud (public) --------------------------------------------
function TSender.GetBaud : integer;
begin
  result := baud;
end;

end.
