unit uSenderEmpfaenger2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, mTNetzHW, mTSender, mTEmpfaenger, StdCtrls;

type
  TForm1 = class(TForm)
    gbEmpf: TGroupBox; mEmpf: TMemo; bLoesche: TButton;
    bStart: TButton; bStop: TButton; gbSend: TGroupBox;
    bSendeText: TButton; mSend: TMemo; gbSettings: TGroupBox;
    lBaud: TLabel; eBaud: TEdit; rbCom1: TRadioButton;
    rbCom2: TRadioButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure bSendeTextClick(Sender: TObject);
    procedure bLoescheClick(Sender: TObject);
    procedure rbCom2Click(Sender: TObject);
    procedure rbCom1Click(Sender: TObject);
    procedure bStopClick(Sender: TObject);
    procedure bStartClick(Sender: TObject);
  private
    HW   : TNetzHW;
    Send : TSender;
    Empf : TEmpfaenger;
    procedure updateView;
    procedure timeout;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  t1,t2 : real;
  c,n   : TLargeInteger;
begin
  QueryPerformanceFrequency(c);
  bStart.Enabled := false;
  HW := TNetzHW.Create;
  HW.Start(1);
  QueryPerformanceCounter(n); t1 := n/c;
  Empf := TEmpfaenger.create;
  Empf.setBaud(StrToInt(eBaud.Text));
  Empf.SetzeHW(HW);
  Empf.OnChange := updateView;
  Empf.Resume;
  QueryPerformanceCounter(n); t2 := n/c;
  //mEmpf.Lines.Add(IntToStr(ord(''))+' '+IntToStr(ord('0'))+' ')
  //mEmpf.Lines.Add(FloatToStr(t2-t1));
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  HW.Free;
  Empf.Terminate;
end;

procedure TForm1.bSendeTextClick(Sender: TObject);
begin
  Send := TSender.create;
  Send.setBaud(StrToInt(eBaud.Text));
  Empf.setBaud(StrToInt(eBaud.Text));
  Send.SetzeHW(HW);
  Send.SetSendeStr(mSend.text);
  Send.Resume;
end;

procedure TForm1.bLoescheClick(Sender: TObject);
begin
  Empf.SetPuffer('');
end;

procedure TForm1.updateView;
begin
  mEmpf.Text := Empf.GetPuffer;
end;

procedure TForm1.rbCom2Click(Sender: TObject);
begin
  HW.Stop; HW.Start(2);
end;

procedure TForm1.rbCom1Click(Sender: TObject);
begin
  HW.Stop; HW.Start(1);
end;

procedure TForm1.bStopClick(Sender: TObject);
begin
  Empf.Terminate;
  bStop.Enabled := false; bStart.Enabled := true;
end;

procedure TForm1.timeout;
begin
  bStop.Enabled := false; bStart.Enabled := true;
end;

procedure TForm1.bStartClick(Sender: TObject);
begin
  Empf := TEmpfaenger.create;
  Empf.setBaud(StrToInt(eBaud.Text));
  Empf.SetzeHW(HW);
  Empf.OnChange := updateView;
  Empf.Resume;
  bStop.Enabled := true; bStart.Enabled := false;
end;

end.
